/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tp2;

/**
 *
 * @author blossier
 */
import java.util.*;
import java.io.*;

public class LectColonne {

    /** compte le nombre de ligne du fichier
     * @param nf : nom du fichier
     * @return nombre de ligne
    */
    
    static int CountLines(String nf) throws Exception {
        int nbre_ligne = 0;
        FileReader fr = new FileReader(nf);
        BufferedReader bf = new BufferedReader(fr);
        while (bf.readLine() != null) {
            nbre_ligne++;
        }
        bf.close();
        fr.close();
        return nbre_ligne;
    }

    
    /**
     * lit j-eme élément de la ligne
     * @param line : ligne
     * @param j : indice de l'élément à récuperer
     * @return le réel correspondant au j-ème élément
     */
    
    static double lireElement(String line, int j) throws Exception {
        StringTokenizer st = new StringTokenizer(line, ";");
        String sval = null;
        for (int k = 0; k < j; k++) {
            sval = st.nextToken();
        }
        return Double.parseDouble(sval);
    }
    
    /** lit une colonne
     * @param nf : nom du fichier
     * @param column : numéro de colonne
     * @param ignore : nbre de lignes en début de fichier à ignorer
     * @return tableau de réels correspondant à la colonne
    */
    
    public static double[] lire(String nf, int column, int ignore) {
        try {      
            double[] result = new double[CountLines(nf) - ignore];
            FileReader fr = new FileReader(nf);
            BufferedReader bf = new BufferedReader(fr);
            String line;
            // ignore les premières lignes
            for (int i = 0; i < ignore; i++) {
                line = bf.readLine();
            }
            // lecture des lignes
            for (int i = 0; i < result.length; i++) {
                line = bf.readLine();
                result[i] =  lireElement(line, column);
            }
            bf.close();
            fr.close();
            return result;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

}
